<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: Target Kernel APIs</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Target Kernel APIs<br/>
<small>
[<a class="el" href="group__group__tivx__api.html">1: TIOVX Interface Modules</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">VX_API_ENTRY <br class="typebreak"/>
<a class="el" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">tivx_target_kernel</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#gac53ae87502b370754a0ae41a1941675a">tivxAddTargetKernel</a> (<a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> kernel_id, char *target_name, <a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a> process_func, <a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a> create_func, <a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a> delete_func, <a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a> control_func, void *priv_arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allows users to add native kernels implementation to specific targets.  <a href="#gac53ae87502b370754a0ae41a1941675a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">VX_API_ENTRY <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#ga857faf8c07c3ee28fa55d7657176447e">tivxRemoveTargetKernel</a> (<a class="el" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">tivx_target_kernel</a> target_kernel)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allows users to remove native kernels implementation to specific targets.  <a href="#ga857faf8c07c3ee28fa55d7657176447e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">VX_API_ENTRY <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#ga551f7060ce2a7e3007424a1da2b184a9">tivxSetTargetKernelInstanceContext</a> (<a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a> target_kernel_instance, void *kernel_context, uint32_t kernel_context_size)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Associate a kernel function context or handle with a target kernel instance.  <a href="#ga551f7060ce2a7e3007424a1da2b184a9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">VX_API_ENTRY <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#ga08730671086c805df9f4e00d4a4ef383">tivxGetTargetKernelInstanceContext</a> (<a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a> target_kernel_instance, void **kernel_context, uint32_t *kernel_context_size)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a kernel function context or handle with a target kernel instance.  <a href="#ga08730671086c805df9f4e00d4a4ef383"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">VX_API_ENTRY void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#gac6174a4e92a4bf4a19ab77a78963ddf5">tivxGetTargetKernelInstanceBorderMode</a> (<a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a> target_kernel_instance, <a class="el" href="structvx__border__t.html">vx_border_t</a> *border_mode)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the border mode for the target kernel instance.  <a href="#gac6174a4e92a4bf4a19ab77a78963ddf5"></a><br/></td></tr>
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <br class="typebreak"/>
_tivx_target_kernel *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">tivx_target_kernel</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Handle to kernel on a target.  <a href="#ga0db4696f0a19630d7f741ab5650be01a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <br class="typebreak"/>
_tivx_target_kernel_instance *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Handle to instance of kernel on a target.  <a href="#ga333da592b786ba63f0a6c9c126eb1cd8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>(VX_CALLBACK *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a> )(<a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a> kernel, <a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params, void *priv_arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The target kernel callback.  <a href="#gaa32576c061941da6b7ad3dd05d8c9569"></a><br/></td></tr>
</table>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="ga0db4696f0a19630d7f741ab5650be01a"></a><!-- doxytag: member="tivx_target_kernel.h::tivx_target_kernel" ref="ga0db4696f0a19630d7f741ab5650be01a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct _tivx_target_kernel* <a class="el" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">tivx_target_kernel</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Handle to kernel on a target. </p>

</div>
</div>
<a class="anchor" id="ga333da592b786ba63f0a6c9c126eb1cd8"></a><!-- doxytag: member="tivx_target_kernel.h::tivx_target_kernel_instance" ref="ga333da592b786ba63f0a6c9c126eb1cd8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct _tivx_target_kernel_instance* <a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Handle to instance of kernel on a target. </p>

</div>
</div>
<a class="anchor" id="gaa32576c061941da6b7ad3dd05d8c9569"></a><!-- doxytag: member="tivx_target_kernel.h::tivx_target_kernel_f" ref="gaa32576c061941da6b7ad3dd05d8c9569" args=")(tivx_target_kernel_instance kernel, tivx_obj_desc_t *obj_desc[], uint16_t num_params, void *priv_arg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>(VX_CALLBACK * <a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a>)(<a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a> kernel, <a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params, void *priv_arg)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The target kernel callback. </p>
<p>For create_func, delete_func and process_func callbacks 'obj_desc' points to array of data object descriptor parameters</p>
<p>For control_func, 'obj_desc' points to array of objects descriptors where obj_desc[0] points to the node object descriptors obj_desc[1..num_params-1] points to target kernel defined parameters</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>kernel</em>&nbsp;</td><td>The kernel for which the callback is called </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>obj_desc</em>&nbsp;</td><td>Object descriptor passed as input to this callback </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="gac53ae87502b370754a0ae41a1941675a"></a><!-- doxytag: member="tivx_target_kernel.h::tivxAddTargetKernel" ref="gac53ae87502b370754a0ae41a1941675a" args="(vx_enum kernel_id, char *target_name, tivx_target_kernel_f process_func, tivx_target_kernel_f create_func, tivx_target_kernel_f delete_func, tivx_target_kernel_f control_func, void *priv_arg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">VX_API_ENTRY <a class="el" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">tivx_target_kernel</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a> tivxAddTargetKernel </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>kernel_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>target_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a>&nbsp;</td>
          <td class="paramname"> <em>process_func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a>&nbsp;</td>
          <td class="paramname"> <em>create_func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a>&nbsp;</td>
          <td class="paramname"> <em>delete_func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">tivx_target_kernel_f</a>&nbsp;</td>
          <td class="paramname"> <em>control_func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>priv_arg</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allows users to add native kernels implementation to specific targets. </p>
<p>This is different from vxAddUserKernel() in that this is called on the target CPU. This is a TI prorietary API and not part of OpenVX or TI OpenVX extention.</p>
<p>This allows users to implement and plugin specific target optimized kernels on TI platforms</p>
<p>A equivalent vxAddUserKernel is typically called to pair the target kernel with OpenVX user kernel. </p>

</div>
</div>
<a class="anchor" id="ga857faf8c07c3ee28fa55d7657176447e"></a><!-- doxytag: member="tivx_target_kernel.h::tivxRemoveTargetKernel" ref="ga857faf8c07c3ee28fa55d7657176447e" args="(tivx_target_kernel target_kernel)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">VX_API_ENTRY <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a> tivxRemoveTargetKernel </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">tivx_target_kernel</a>&nbsp;</td>
          <td class="paramname"> <em>target_kernel</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allows users to remove native kernels implementation to specific targets. </p>

</div>
</div>
<a class="anchor" id="ga551f7060ce2a7e3007424a1da2b184a9"></a><!-- doxytag: member="tivx_target_kernel.h::tivxSetTargetKernelInstanceContext" ref="ga551f7060ce2a7e3007424a1da2b184a9" args="(tivx_target_kernel_instance target_kernel_instance, void *kernel_context, uint32_t kernel_context_size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">VX_API_ENTRY <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a> tivxSetTargetKernelInstanceContext </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a>&nbsp;</td>
          <td class="paramname"> <em>target_kernel_instance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>kernel_context</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>kernel_context_size</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Associate a kernel function context or handle with a target kernel instance. </p>
<p>Typically set by the kernel function during create phase </p>

</div>
</div>
<a class="anchor" id="ga08730671086c805df9f4e00d4a4ef383"></a><!-- doxytag: member="tivx_target_kernel.h::tivxGetTargetKernelInstanceContext" ref="ga08730671086c805df9f4e00d4a4ef383" args="(tivx_target_kernel_instance target_kernel_instance, void **kernel_context, uint32_t *kernel_context_size)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">VX_API_ENTRY <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> <a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a> tivxGetTargetKernelInstanceContext </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a>&nbsp;</td>
          <td class="paramname"> <em>target_kernel_instance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void **&nbsp;</td>
          <td class="paramname"> <em>kernel_context</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&nbsp;</td>
          <td class="paramname"> <em>kernel_context_size</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a kernel function context or handle with a target kernel instance. </p>
<p>Typically used by the kernel function during run, control, delete phase </p>

</div>
</div>
<a class="anchor" id="gac6174a4e92a4bf4a19ab77a78963ddf5"></a><!-- doxytag: member="tivx_target_kernel.h::tivxGetTargetKernelInstanceBorderMode" ref="gac6174a4e92a4bf4a19ab77a78963ddf5" args="(tivx_target_kernel_instance target_kernel_instance, vx_border_t *border_mode)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">VX_API_ENTRY void tivxGetTargetKernelInstanceBorderMode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">tivx_target_kernel_instance</a>&nbsp;</td>
          <td class="paramname"> <em>target_kernel_instance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structvx__border__t.html">vx_border_t</a> *&nbsp;</td>
          <td class="paramname"> <em>border_mode</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the border mode for the target kernel instance. </p>
<p>Used by the kernel implemention to get border mode </p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
